<?php

# TODO: Icon ersetzen?
# --> Ersetzt das vorgebene SFX-Symbol durch das Symbol/die Symbole aus der angebenen .ico Datei. Diese Datei mu mindestens ein 32x32 Symbol mit 16 und/oder 256 Farben enthalten. Es empfiehlt sich auch 16x16 Ikons mit hinzuzufgen.
  
require('zip.lib.php');

class sfx extends zipfile {
	
	var $sfx_header = '';
	var	$sfx_script = array();
	//var	$sfx_scripttext = '';

	function sfx($lang='en', $use_upx=false){
		$this->sfx_header = dirname(__FILE__).'/sfx/zip.sfx.'.$lang; #_header_zip.dat';
		if ($use_upx) $this->sfx_header .= '.upx';
	}
	
//	function setScript($script_text){
//		$this->sfx_scripttext = $script_text;
//	}
	
	function file($filename=false){

		#$output = 'test.exe';
		$zip_data = parent::file();
		
		$header_size = filesize($this->sfx_header);
		$zip_size    = strlen($zip_data);          #filesize($zip_file)
		
		$sfx_scripttext = $this->getScript();
		$footer_size = strlen($sfx_scripttext);  #filesize($this->sfx_footer);
		
		if ($filename){
			// send the right headers
			header('Content-Type: application/octet-stream');
			header('Content-Length: ' . ($header_size + $zip_size + $footer_size));
			
			header('Expires: '.gmdate('D, d M Y H:i:s').' GMT');
			header('Content-Disposition: attachment; filename="'.$filename.'"');
			header('Pragma: no-cache');
		}
				
		if ($this->sfx_script!=''){
			$zip_data{$zip_size-2} = chr($footer_size % 256);
			$zip_data{$zip_size-1} = chr($footer_size / 256);
		}
		
		if ($filename)
			echo file_get_contents($this->sfx_header) . $zip_data . $sfx_scripttext;
		else
			return file_get_contents($this->sfx_header) . $zip_data . $sfx_scripttext;
	}


	/* SCRIPT-COMMANDS */
	function setLicence($txt, $title=''){
		$this->sfx_script['licence'] = $txt;
		$this->sfx_script['licence_title'] = $title;
	}
	function setTitle($title){
		$this->sfx_script['title'] = $title;
	}
	function setText($txt){
		$this->sfx_script['text'] = $txt;
	}
	function setPath($path){
		$this->sfx_script['path'] = $path;
	}	
	function setSavePath($flag){
		$this->sfx_script['save_path'] = $flag;
	}		
	function setOverwrite($n){
		$this->sfx_script['overwrite'] = $n;
	}
	function setSilent($n){
		$this->sfx_script['silent'] = $n;
	}	
	function setSetup($cmd){
		$this->sfx_script['setup'] = $cmd;
	}
	function setPresetup($cmd){
		$this->sfx_script['presetup'] = $cmd;
	}
	function setTempMode($flag){
		$this->sfx_script['temp_mode'] = $flag;
	}
	function setDelete($files){
		if (!is_array($files)) $files=array($files);
		$this->sfx_script['delete'] = $files;
	}
	function setShortcuts($shortcuts){
		if (!is_array($shortcuts)) $shortcuts=array($shortcuts);
		$this->sfx_script['shortcuts'] = $shortcuts;
	}
		
	function getScript(){
		$sfx_scripttext = ''; #";Der Kommentar unten enthlt SFX Skript Befehle!\n\n";
		if (isset($this->sfx_script['title'])) $sfx_scripttext .= 'Title='.$this->sfx_script['title']."\n";
		
		if (isset($this->sfx_script['text'])) $sfx_scripttext .= "Text\n{\n". str_replace("\n}","  \n}", $this->sfx_script['text']) ."\n}\n";
		
		if (isset($this->sfx_script['licence'])) $sfx_scripttext .= 'License='.$this->sfx_script['licence_title']."\n{\n". str_replace("\n}","  \n}", $this->sfx_script['licence']) ."\n}\n";
		if (isset($this->sfx_script['path'])) $sfx_scripttext .= 'Path='.$this->sfx_script['path']."\n";
		if (@$this->sfx_script['save_path']==true) $sfx_scripttext .= "SavePath\n";		
		if (isset($this->sfx_script['overwrite'])) $sfx_scripttext .= 'Overwrite='.$this->sfx_script['overwrite']."\n";
		if (isset($this->sfx_script['silent'])) $sfx_scripttext .= 'Silent='.$this->sfx_script['silent']."\n";
		if (isset($this->sfx_script['setup'])) $sfx_scripttext .= 'Setup='.$this->sfx_script['setup']."\n";
		if (isset($this->sfx_script['presetup'])) $sfx_scripttext .= 'Presetup='.$this->sfx_script['presetup']."\n";
		if (@$this->sfx_script['temp_mode']==true) $sfx_scripttext .= "TempMode\n";
		
		if (isset($this->sfx_script['delete'])) 
			foreach ($this->sfx_script['delete'] as $f)
				$sfx_scripttext .= "Delete=$f\n";
				
		if (isset($this->sfx_script['shortcuts'])) 
			foreach ($this->sfx_script['shortcuts'] as $s)
				$sfx_scripttext .= "Shortcut=$s\n";				
				
		if ($sfx_scripttext!='') 
			$sfx_scripttext = ";Der Kommentar unten enthlt SFX Skript Befehle!\n\n".$sfx_scripttext;
		
		return $sfx_scripttext;
	}
} # END OF CLASS


/*

;Der Kommentar unten enthlt SFX Skript Befehle!

Path=c:\xxx
SavePath
Setup=setup
Presetup=vorher
TempMode
Silent=1
Overwrite=1
Delete=xxx
Delete=yyy
Shortcut=D, "aaa", "bbb", "ccc", "ddd"
Shortcut=S, "www", "xxx", "yyy", "zzz"

Title=myphotobook 3.01 Installation
Text
{
<font face="Arial" size="2"><b>Willkommen beim Installations-Assistenten <br>fr myphotobook 3.01</b><br>
<br>
myphotobook 3.01 wird in das unten angegebene Verzeichnis installiert.</font>
}
License=myphotobook 3.01 Installation
{
<font face="Arial" size="2"><b>Endbenutzerlizenzvereinbarung (EBLV)</b><br>
<br>
<b>Allgemeines</b><br>
<br>
Die myphotobook GmbH (nachfolgend myphotobook) macht als Lizenzgeberin eine Layoutsoftware zur Herstellung von Fotobchern ber das Internet der ffentlichkeit zugnglich.
</font>
}


*/

?>